/* eslint-disable @typescript-eslint/no-explicit-any */
/* eslint-disable react/display-name */
import React from 'react'
import ReactDOM from 'react-dom/client'
import { i18nextReactInitConfig } from '@brojs/cli'
import i18next from 'i18next'

i18next.t = i18next.t.bind(i18next)
const config = i18nextReactInitConfig(i18next)
  
import App from './app'
  
export default () => <App/>
  
let rootElement: ReactDOM.Root
  
export const mount = async (Сomponent, element = document.getElementById('app')) => {
  await config
  rootElement = ReactDOM.createRoot(element)
  rootElement.render(<Сomponent/>)

  if(module.hot) {
    module.hot.accept('./app', ()=> {
      rootElement.render(<Сomponent/>)
    })
  }
}

export const unmount = () => {
  rootElement.unmount()
}
